//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include <shellapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Label1->Caption = "Ver.0.11";
	fo = -1;
	ox = Panel0->Width + 1;
	px = Form1->ClientWidth - ox - 1;
	py = Panel0->Height - 2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	DragAcceptFiles(Handle, True);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
	if(RadioGroup1->ItemIndex == 0){
		RadioGroup2->Visible = false;
	}else{
		RadioGroup2->Visible = true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReceiveDropFiles(TWMDropFiles Message)
{
	FILE 	*handle;
	char	*s, st[512]="";
	const int NameMax = 1024;
	char FileName[NameMax + 10];

	HDROP &Drop = (HDROP)Message.Drop;
	int Files = DragQueryFile(Drop, 0xFFFFFFFF, NULL, 0);
	for (int n = 0; n < Files; n++){
		DragQueryFile(Drop, n, FileName, NameMax);
	}
	DragFinish(Drop);
	s = strrchr(FileName, '.') + 1;
	if(!strcmp(s, "csv")){
		Panel1->Caption = strrchr(FileName, '\\') + 1;
		if((handle = fopen(FileName, "rt")) == NULL){
			perror("ǍG[");
		}else{
			if(RadioGroup1->ItemIndex == 0){							// 2D
				read_2D(handle);
				draw_2D();
			}else{														// 3D
				read_3D(handle);
				draw_3D();
			}
			fclose(handle);
			fo = 0;
		}
		strcpy(st, Panel1->Caption.c_str());
		st[strrchr(st, '.')-st] = '\0';
		strcat(st, ".dxf");
		SaveDialog1->FileName = st;
		StatusBar1->SimpleText = "o";
		if(SaveDialog1->Execute()){
			s = SaveDialog1->FileName.c_str();
			if((handle = fopen(s, "wt")) == NULL){
				perror("݃G[");
			}else{
				write_D(handle);
				fclose(handle);
				StatusBar1->SimpleText = "ϊ";
			}
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	FILE 	*handle;
	char	*s, st[512]="";
	int 	c, d, e;

	if(OpenDialog1->Execute()){
		s = OpenDialog1->FileName.c_str();
		Panel1->Caption = strrchr(s, '\\') + 1;
		if((handle = fopen(s, "rt")) == NULL){
			perror("ǍG[");
		}else{
			if(RadioGroup1->ItemIndex == 0){							// 2D
				read_2D(handle);
				draw_2D();
			}else{														// 3D
				read_3D(handle);
				draw_3D();
			}
			fclose(handle);
			fo = 0;
		}
		strcpy(st, Panel1->Caption.c_str());
		st[strrchr(st, '.')-st] = '\0';
		strcat(st, ".dxf");
		SaveDialog1->FileName = st;
		StatusBar1->SimpleText = "o";
	}
}
//---------------------------------------------------------------------------
void TForm1::read_2D(FILE *handle)
{
	char	st[512]="", ch[2]="0";
	int 	c, d, e;

	d = e = 0;
	while((c = fgetc(handle)) != EOF){
		if(c == '\n'){
			data[d][e] = strtod(st, NULL);
			if(e){
				if(d){
					if(ymin > data[d][e])	ymin = data[d][e];
					if(ymax < data[d][e])	ymax = data[d][e];
				}else{
					if(xmin > data[d][e])	xmin = data[d][e];
					if(xmax < data[d][e])	xmax = data[d][e];
				}
			}else{
				if(d)	ymin = ymax = data[d][e];
				else	xmin = xmax = data[d][e];
			}
			strcpy(st, "");
			if(d)	break;
			mx = e;
			d = 1;
			e = 0;
		}else if(c == ','){
			data[d][e] = strtod(st, NULL);
			if(e){
				if(d){
					if(ymin > data[d][e])	ymin = data[d][e];
					if(ymax < data[d][e])	ymax = data[d][e];
				}else{
					if(xmin > data[d][e])	xmin = data[d][e];
					if(xmax < data[d][e])	xmax = data[d][e];
				}
			}else{
				if(d)	ymin = ymax = data[d][e];
				else	xmin = xmax = data[d][e];
			}
			strcpy(st, "");
			e++;
		}else if(isdigit(c) || c == '+' || c == '-' || c == '.'){
			ch[0] = char(c);
			strcat(st, ch);
		}
	}
}
//---------------------------------------------------------------------------
void TForm1::read_3D(FILE *handle)
{
	char	st[512]="", ch[2]="0";
	int 	c, d, e;
	double	x, y;

	d = e = 0;
	while((c = fgetc(handle)) != '\n'){
		if(c == ','){
			data[d][e] = strtod(st, NULL);
			strcpy(st, "");
			e++;
		}else if(isdigit(c) || c == '+' || c == '-' || c == '.'){
			ch[0] = char(c);
			strcat(st, ch);
		}
	}
	data[d][e] = strtod(st, NULL);
	strcpy(st, "");
	mx = e;
	d = 1;
	e = 0;
	while((c = fgetc(handle)) != EOF){
		if(c == '\n'){
			data[d][e] = strtod(st, NULL);
			if(e == 1 && d == 1){
				xmin = xmax = 0.866 * (data[0][e] + data[d][0]);
				ymin = ymax = 0.5 * (data[d][0] - data[0][e]) + data[d][e];
			}else if(e){
				x = 0.866 * (data[0][e] + data[d][0]);
				y = 0.5 * (data[d][0] - data[0][e]) + data[d][e];
				if(xmin > x)	xmin = x;
				if(xmax < x)	xmax = x;
				if(ymin > y)	ymin = y;
				if(ymax < y)	ymax = y;
			}
			strcpy(st, "");
			my = d;
			d++;
			e = 0;
		}else if(c == ','){
			data[d][e] = strtod(st, NULL);
			if(e == 1 && d == 1){
				xmin = xmax = 0.866 * (data[0][e] + data[d][0]);
				ymin = ymax = 0.5 * (data[d][0] - data[0][e]) + data[d][e];
			}else if(e){
				x = 0.866 * (data[0][e] + data[d][0]);
				y = 0.5 * (data[d][0] - data[0][e]) + data[d][e];
				if(xmin > x)	xmin = x;
				if(xmax < x)	xmax = x;
				if(ymin > y)	ymin = y;
				if(ymax < y)	ymax = y;
			}
			strcpy(st, "");
			e++;
		}else if(isdigit(c) || c == '+' || c == '-' || c == '.'){
			ch[0] = char(c);
			strcat(st, ch);
		}
	}
}
//---------------------------------------------------------------------------
void TForm1::draw_2D()
{
	int 	i, j, x, y, qx;
	double	d, dx, dy, s;

	Canvas->Pen->Color = clWhite;
	Canvas->Rectangle(ox,0,ox+px+1,py+1);
	Canvas->Pen->Color = clBlack;
	dx = xmax - xmin;
	dy = ymax - ymin;
	d = dy / 0.75;
	if(d < dx){
		s = px / dx;
		qx = ox;
	}else{
		s = py / dy;
		qx = ox + (int)((d - dx) / 2 * s);
	}
	x = qx + (int)((data[0][0] - xmin) * s);
	y = py - (int)((data[1][0] - ymin) * s);
	Canvas->MoveTo(x,y);
	for(i = 1; i <= mx; i++){
		x = qx + (int)((data[0][i] - xmin) * s);
		y = py - (int)((data[1][i] - ymin) * s);
		Canvas->LineTo(x,y);
	}
}
//---------------------------------------------------------------------------
void TForm1::draw_3D()
{
	int 	i, j, x, y, qx;
	double	d, dx, dy, s;

	Canvas->Pen->Color = clWhite;
	Canvas->Rectangle(ox,0,ox+px+1,py+1);
	Canvas->Pen->Color = clBlack;
	dx = xmax - xmin;
	dy = ymax - ymin;
	d = dy / 0.75;
	if(d < dx){
		s = px / dx;
		qx = ox;
	}else{
		s = py / dy;
		qx = ox + (int)((d - dx) / 2 * s);
	}
	for(i = 1; i <= mx; i++){
		x = qx + (int)((0.866 * (data[0][i] + data[1][0]) - xmin) * s);
		y = py - (int)(((0.5 * (data[1][0] - data[0][i]) + data[1][i]) - ymin) * s);
		Canvas->MoveTo(x,y);
		for(j = 2; j <= my; j++){
			x = qx + (int)((0.866 * (data[0][i] + data[j][0]) - xmin) * s);
			y = py - (int)(((0.5 * (data[j][0] - data[0][i]) + data[j][i]) - ymin) * s);
			Canvas->LineTo(x,y);
		}
	}
	for(j = 1; j <= my; j++){
		x = qx + (int)((0.866 * (data[0][1] + data[j][0]) - xmin) * s);
		y = py - (int)(((0.5 * (data[j][0] - data[0][1]) + data[j][1]) - ymin) * s);
		Canvas->MoveTo(x,y);
		for(i = 2; i <= mx; i++){
			x = qx + (int)((0.866 * (data[0][i] + data[j][0]) - xmin) * s);
			y = py - (int)(((0.5 * (data[j][0] - data[0][i]) + data[j][i]) - ymin) * s);
			Canvas->LineTo(x,y);
		}
	}
}
//---------------------------------------------------------------------------
void TForm1::write_D(FILE *handle)
{
	int 	i, j;

	fprintf(handle, "  0\nSECTION\n");
	fprintf(handle, "  2\nENTITIES\n");
	if(RadioGroup1->ItemIndex == 0){
		fprintf(handle, "  0\nPOLYLINE\n");
		fprintf(handle, "  8\ncsv2dx23\n");
		fprintf(handle, " 66\n1\n");
		fprintf(handle, " 70\n0\n");
		for(i = 0; i <= mx; i++){
			fprintf(handle, "  0\nVERTEX\n");
			fprintf(handle, " 10\n%f\n", data[0][i]);
			fprintf(handle, " 20\n%f\n", data[1][i]);
		}
		fprintf(handle, "  0\nSEQEND\n");
	}else if(RadioGroup2->ItemIndex == 0){					// Line
		for(i = 1; i <= mx; i++){
			fprintf(handle, "  0\nPOLYLINE\n");
			fprintf(handle, "  8\ncsv2dx23\n");
			fprintf(handle, " 66\n1\n");
			fprintf(handle, " 70\n8\n");
			for(j = 1; j <= my; j++){
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[0][i]);
				fprintf(handle, " 20\n%f\n", data[j][0]);
				fprintf(handle, " 30\n%f\n", data[j][i]);
			}
			fprintf(handle, "  0\nSEQEND\n");
		}
		for(j = 1; j <= my; j++){
			fprintf(handle, "  0\nPOLYLINE\n");
			fprintf(handle, "  8\ncsv2dx23\n");
			fprintf(handle, " 66\n1\n");
			fprintf(handle, " 70\n8\n");
			for(i = 1; i <= mx; i++){
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[0][i]);
				fprintf(handle, " 20\n%f\n", data[j][0]);
				fprintf(handle, " 30\n%f\n", data[j][i]);
			}
			fprintf(handle, "  0\nSEQEND\n");
		}
	}else if(RadioGroup2->ItemIndex == 1){					// 3D Face
		for(i = 1; i < mx; i++){
			for(j = 1; j < my; j++){
				fprintf(handle, "  0\n3DFACE\n");
				fprintf(handle, "  8\ncsv2dx23\n");
				fprintf(handle, " 10\n%f\n", data[0][i]);
				fprintf(handle, " 20\n%f\n", data[j][0]);
				fprintf(handle, " 30\n%f\n", data[j][i]);
				fprintf(handle, " 11\n%f\n", data[0][i+1]);
				fprintf(handle, " 21\n%f\n", data[j][ 0 ]);
				fprintf(handle, " 31\n%f\n", data[j][i+1]);
				fprintf(handle, " 12\n%f\n", data[ 0 ][i+1]);
				fprintf(handle, " 22\n%f\n", data[j+1][ 0 ]);
				fprintf(handle, " 32\n%f\n", data[j+1][i+1]);
				fprintf(handle, " 13\n%f\n", data[ 0 ][i]);
				fprintf(handle, " 23\n%f\n", data[j+1][0]);
				fprintf(handle, " 33\n%f\n", data[j+1][i]);
			}
		}
	}else if(RadioGroup2->ItemIndex == 2){					// Polygon
		for(i = 1; i < mx; i++){
			for(j = 1; j < my; j++){
				fprintf(handle, "  0\nPOLYLINE\n");
				fprintf(handle, "  8\ncsv2dx23\n");
				fprintf(handle, " 66\n1\n");
				fprintf(handle, " 70\n9\n");
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[0][i]);
				fprintf(handle, " 20\n%f\n", data[j][0]);
				fprintf(handle, " 30\n%f\n", data[j][i]);
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[0][i+1]);
				fprintf(handle, " 20\n%f\n", data[j][ 0 ]);
				fprintf(handle, " 30\n%f\n", data[j][i+1]);
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[ 0 ][i+1]);
				fprintf(handle, " 20\n%f\n", data[j+1][ 0 ]);
				fprintf(handle, " 30\n%f\n", data[j+1][i+1]);
				fprintf(handle, "  0\nVERTEX\n");
				fprintf(handle, " 10\n%f\n", data[ 0 ][i]);
				fprintf(handle, " 20\n%f\n", data[j+1][0]);
				fprintf(handle, " 30\n%f\n", data[j+1][i]);
				fprintf(handle, "  0\nSEQEND\n");
			}
		}
	}else if(RadioGroup2->ItemIndex == 3){					// Triangle Patch
		for(i = 1; i < mx; i++){
			for(j = 1; j < my; j++){
				fprintf(handle, "  0\n3DFACE\n");
				fprintf(handle, "  8\ncsv2dx23\n");
				fprintf(handle, " 10\n%f\n", data[0][i]);
				fprintf(handle, " 20\n%f\n", data[j][0]);
				fprintf(handle, " 30\n%f\n", data[j][i]);
				fprintf(handle, " 11\n%f\n", data[0][i+1]);
				fprintf(handle, " 21\n%f\n", data[j][ 0 ]);
				fprintf(handle, " 31\n%f\n", data[j][i+1]);
				fprintf(handle, " 12\n%f\n", data[ 0 ][i]);
				fprintf(handle, " 22\n%f\n", data[j+1][0]);
				fprintf(handle, " 32\n%f\n", data[j+1][i]);
				fprintf(handle, " 13\n%f\n", data[ 0 ][i]);
				fprintf(handle, " 23\n%f\n", data[j+1][0]);
				fprintf(handle, " 33\n%f\n", data[j+1][i]);
				fprintf(handle, "  0\n3DFACE\n");
				fprintf(handle, "  8\ncsv2dx23\n");
				fprintf(handle, " 10\n%f\n", data[ 0 ][i]);
				fprintf(handle, " 20\n%f\n", data[j+1][0]);
				fprintf(handle, " 30\n%f\n", data[j+1][i]);
				fprintf(handle, " 11\n%f\n", data[0][i+1]);
				fprintf(handle, " 21\n%f\n", data[j][ 0 ]);
				fprintf(handle, " 31\n%f\n", data[j][i+1]);
				fprintf(handle, " 12\n%f\n", data[ 0 ][i+1]);
				fprintf(handle, " 22\n%f\n", data[j+1][ 0 ]);
				fprintf(handle, " 32\n%f\n", data[j+1][i+1]);
				fprintf(handle, " 13\n%f\n", data[ 0 ][i+1]);
				fprintf(handle, " 23\n%f\n", data[j+1][ 0 ]);
				fprintf(handle, " 33\n%f\n", data[j+1][i+1]);
			}
		}
	}
	fprintf(handle, "  0\nENDSEC\n");
	fprintf(handle, "  0\nEOF\n");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	FILE	*handle;
	char	*s;
	int 	i, j;

	if(fo)	return;
	if(SaveDialog1->Execute()){
		s = SaveDialog1->FileName.c_str();
		if((handle = fopen(s, "wt")) == NULL){
			perror("݃G[");
		}else{
			write_D(handle);
			fclose(handle);
			StatusBar1->SimpleText = "ۑ";
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	exit(EXIT_SUCCESS);
}
//---------------------------------------------------------------------------

